#! /usr/bin/perl

############################################################
# filetime.cgi v2.0 (Aug-17-2002)                          #
############################################################
# Copyright (C) 1999-2002 Kan-chan <hana@goyomi.club.ne.jp>#
#  Web site: http://kan-chan.stbbs.net/download/           #
############################################################
# This program is free software; you can redistribute it   #
# and/or modify it under the terms of the GNU General      #
# Public License as published by the Free Software         #
# Foundation; either version 2 of the License, or (at your #
# option) any later version.                               #
#                                                          #
# This program is distributed in the hope that it will be  #
# useful, but WITHOUT ANY WARRANTY; without even the       #
# implied warranty of MERCHANTABILITY or FITNESS FOR A     #
# PARTICULAR PURPOSE. See the GNU General Public License   #
# for more details.                                        #
#                                                          #
# You should have received a copy of the GNU General       #
# Public License along with this program; if not, write to #
# the Free Software Foundation, Inc., 675 Mass Ave,        #
# Cambridge, MA 02139, USA.                                #
############################################################

# Release note:
# v2.0  (Aug-17-2002)
#  Supports HTML 4.01 Transitional and CSS2
# v1.3  (Feb-01-2000)
#   Fixed a bug of 'Headline mode' on MiniBBS v10
# v1.2  (Jan-01-2000)
#   Fixed a Y2K bug
# v1.1  (Date unknown)
#   Added 'Headline mode' for MiniBBS which is released at www.rescue.ne.jp
#   Added 'Description'
# v1.0  (Date unknown)
#   First release
#
# usage:
# 1. Modify the top of this script (/usr/local/bin/perl) if it is required.
# 2. Add &subt() to add a subtitle, add &disp() to add a link and its time
# 3. Upload this file and a stylesheet file to your html directory.
# 4. chmod this file.  (705 or 755)  e.g.  chmod 705 filetime.cgi
#
############################################################

# Language
# If you'd like to display in Japanese, activate "jp" and deactivate "en"
#$lang = "en";
$lang = "jp";

# Title
$title = "The updated dates of each files";

# CSS file
$css = "iris.css";

# Directory where this script exists
$base = "http://anywhere";

# When the color of date changes and each colors
# By default, Red until 1 day passes / Blue : 3 / Green : 7 / Black after 1 week
$intv1 = 1 * 24 *(60*60);
$intv2 = 3 * 24 *(60*60);
$intv3 = 7 * 24 *(60*60);

#Max. Number of Headline
$headlinemax = 20;

############################################################

#Time zone
$ENV{'TZ'} = "JST-9";

# Days of week in Japanese (Shift JIS)
@wdays_j = ( "", "", "", "", "", "", "y", "" );
# Days of week in English
@wdays_e = ( "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun" );

############################################################

	if ($lang eq "jp"){
		print << "EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title>$title</title>
</head>
<body>
<h1>$title</h1>
<table>
EOF
	} else{
		print << "EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="en">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>$title</title>
</head>
<body>
<h1>$title</h1>
<table>
EOF
	}

# Items - begin (You have to modify them!)
#   &subt(subtitle);
#   &disp(file to monitor, file to link, item, description, mode);
#   mode : "hl" - work as MiniBBS(v7-10) headline mode

&subt('Pages');
&disp('../index.html','../index.html','Index','Index of home page.','');
&subt('BBS');
&disp('./minibbs.dat','./minibbs.cgi','MiniBBS','Please feel free to write!','hl');

# Items - end

print << "EOF";
</table>
<hr>
<p class="copyright"><a href="http://kan-chan.stbbs.net/download/" target="_blank">filetime v2.0</a></p>
</body>
</html>
EOF
exit;

sub subt{
	print << "EOF";
<tr>
<td class="h1" colspan="4">$_[0]</td>
</tr>
EOF
}

sub disp{
	$file1 = $_[0];
	$file2 = $_[1];
	$name = $_[2];
	$description = $_[3];
	$mode = $_[4];
	$filedate = (stat($file1))[9];

# To fix time, add/substruct seconds to/from $filedate.
#  e.g.  +9 : ... = localtime($filedate + 9*60*60);
#  e.g.  -9 : ... = localtime($filedate - 9*60*60);
	($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($filedate);
# Fixed a Y2K bug
	$year += 1900;
	if ($lang eq "jp"){
		$date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year, $mon + 1, $mday, @wdays_j[$wday], $hour, $min);
	} else{
		$date = sprintf("%s, %02d/%02d/%04d %02d:%02d",
				@wdays_e[$wday], $mon + 1, $mday, $year, $hour, $min);
	}

# Determine the class
	if ((time()-$filedate) < $intv1){
		$class = "filetime_status1";
	} else{
		if ((time()-$filedate) < $intv2){
			$class = "filetime_status2";
		} else{
			if ((time()-$filedate) < $intv3){
				$class = "filetime_status3";
			} else{
				$class = "filetime_status4";
			}
		}
	}

# Get headline
	$headline = '';
	if ($mode eq 'hl'){
		$headline = '<br>';
		$headline .= &headline($file1);
	}

	print << "EOF";
<tr>
<td class="indention"></td>
<td class="item"><a href="$base$file2" target="_blank">$name</a></td>
<td class="detail"><span class="$class">$date</span></td>
<td class="detail">$description$headline</td>
</tr>
EOF
}

sub headline{
	$file1 = $_[0];
	$result = '';

	if (!open(DB,"$file1")) { return 'Error: file not found.'; }
	@lines = <DB>;
	close(DB);
	$header = shift(@lines);
	($header,$password) = split(/:/,$header);

	if ($header ne 'MiniBBSv10') { @lines = reverse(@lines); }
	$page_end = $headlinemax;
	if ($#lines < $headlinemax) { $page_end = $#lines + 1; }
	foreach (0 .. $page_end - 1) {
		$subject = '';
		if ($header eq 'crypt_password') {	#MiniBBS v7
			($f1,$f2,$f3,$f4,$f5,$f6) = split(/\,/,$lines[$_]);
			$subject = $f5;
		}
		if (($header eq 'MiniBBSv8') || ($header eq 'MiniBBSv9')) {
			if ($lines[$_] =~ /^\"(\d+)\"\,\"(.*)\"\,\"(.*)\"\,\"(.*)\"\,\"(.*)\"\,\"(.*)\"\,\"(.*)\"\,\"(.*)\"\,\"(.*)\",\"(.*)\"/){
				$subject = $7;
			}
		}
		if ($header eq 'MiniBBSv10') {
			($f1,$f2,$f3,$f4,$f5,$f6,$f7,$f8,$f9,$f10,$f11) = split(/\t/,$lines[$_]);
			$subject = $f7;
		}
		$number = $_ + 1;
		$result .= "<b>$number:</b> $subject  ";
	}
	return $result;
}
