#! /usr/bin/perl

############################################################
# filetime.pl v2.0 (Aug-17-2002)                           #
############################################################
# Copyright (C) 1999-2002 Kan-chan <hana@goyomi.club.ne.jp>#
#  Web site: http://kan-chan.stbbs.net/download/           #
############################################################
# This program is free software; you can redistribute it   #
# and/or modify it under the terms of the GNU General      #
# Public License as published by the Free Software         #
# Foundation; either version 2 of the License, or (at your #
# option) any later version.                               #
#                                                          #
# This program is distributed in the hope that it will be  #
# useful, but WITHOUT ANY WARRANTY; without even the       #
# implied warranty of MERCHANTABILITY or FITNESS FOR A     #
# PARTICULAR PURPOSE. See the GNU General Public License   #
# for more details.                                        #
#                                                          #
# You should have received a copy of the GNU General       #
# Public License along with this program; if not, write to #
# the Free Software Foundation, Inc., 675 Mass Ave,        #
# Cambridge, MA 02139, USA.                                #
############################################################

# Release note:
# v2.0  (Aug-17-2002)
#  Supports HTML 4.01 Transitional and CSS2
#  Removed D(Darker background) option
# v1.2 (Jan-01-2000)
#   Fixed a Y2K bug
# v1.0 (Date unknown)
#   First release
#
# usage:
# 1. Modify the top of this script (/usr/local/bin/perl) if it is required.
# 2. Upload this file and a stylesheet file to your html directory.
# 3. chmod this file.  (705 or 755)  e.g.  chmod 705 filetime.pl
# 4. Write the following SSI command to your html file
#    <!--#exec cmd="(path)/filetime.pl (file to know date) (options)"-->
#    Options: E(English)/J(Japanese;default)
#    e.g.  <!--#exec cmd="cgi-bin/filetime.pl index.html"-->
#          then, modified date of index.html will be written there.
#    e.g.  <!--#exec cmd="cgi-bin/filetime.pl index.html E"-->
#          use english.
#
############################################################

# Default language
$lang = "jp";
#$lang = "en";

# When the color of date changes and each colors
# By default, Red until 1 day passes / Blue : 3 / Green : 7 / Black after 1 week
$intv1 = 1 * 24 *(60*60);
$intv2 = 3 * 24 *(60*60);
$intv3 = 7 * 24 *(60*60);

############################################################

#Time zone
$ENV{'TZ'} = "JST-9";

# Days of week in Japanese (Shift JIS)
@wdays_j = ( "", "", "", "", "", "", "y", "" );
# Days of week in English
@wdays_e = ( "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun" );

############################################################

&disp($ARGV[0],$ARGV[1]);
exit;

sub disp{
# Parse command line
	$file1 = $_[0];
	$opt = $_[1];
	$filedate = (stat($file1))[9];
	if ($file1 eq ""){
		print "[file not found!]";
		exit(1);
	}
	if ($opt =~ /E/) { $lang = "en"; }
	if ($opt =~ /J/) { $lang = "jp"; }

# To fix time, add/substruct seconds to/from $filedate.
#  e.g.  +9 : ... = localtime($filedate + 9*60*60);
#  e.g.  -9 : ... = localtime($filedate - 9*60*60);
	($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($filedate );
# Fixed a Y2K bug
	$year += 1900;
	if ($lang eq "jp"){
		$date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year, $mon + 1, $mday, @wdays_j[$wday], $hour, $min);
	} else{
		$date = sprintf("%s, %02d/%02d/%04d %02d:%02d",
				@wdays_e[$wday], $mon + 1, $mday, $year, $hour, $min);
	}

# Determine the class
	if ((time()-$filedate) < $intv1){
		$class = "filetime_status1";
	} else{
		if ((time()-$filedate) < $intv2){
			$class = "filetime_status2";
		} else{
			if ((time()-$filedate) < $intv3){
				$class = "filetime_status3";
			} else{
				$class = "filetime_status4";
			}
		}
	}
	print "<span class=\"$class\">$date</span>";
}
